'==========================================================================
'PCXMAN - QBASIC PCX FILE MANIPULATER V1.0 BY SHOGUNTIM
'SEPTEMBER 1996
'FREELY DISTRIBUTED
'Email me at ShogunTim@aol.com
'============================================================================
'Read readme.txt for more information


DECLARE SUB SAVESCREEN ()
DECLARE SUB GETPAL ()
DECLARE SUB INPUTFILE ()
DECLARE SUB DECODE ()
DECLARE SUB TINYDRAW ()
DECLARE SUB FLOODPAL (floodcolor!)
DECLARE SUB BRIGHTNESS (preference!, palstyle!)
DECLARE SUB SCALEIT ()

COMMON SHARED bigoffsetx, bigoffsety, palstyle
COMMON SHARED floodcolor AS INTEGER
COMMON SHARED pointer, onepercent, normal, abnormal
COMMON SHARED pcxfile$, dir$
COMMON SHARED horposition%, verposition%

'''''''''''PUT YOUR ALTERNATE DIRECTORY HERE (OPTIONAL) ''''''''''''''''''''

dir$ = ""      'example "c:\my\directory\"
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


SCREEN 13: CLS

TYPE pcxtype
mf AS STRING * 1
version AS STRING * 1
encoding AS STRING * 1
bpp AS STRING * 1
xxxx AS INTEGER
yyyy AS INTEGER
thewidth AS INTEGER
theheigth AS INTEGER
horpixels AS INTEGER
vetpixels AS INTEGER
ega AS STRING * 48
reserved AS STRING * 1
planes AS STRING * 1
bpl AS INTEGER
paltype AS INTEGER
padding AS STRING * 58
END TYPE

DIM SHARED headerinfo AS pcxtype


CONST palbytes = 768
CONST header = 128
CONST yes = 1, no = 0, maybe = 666

TYPE copaltype
r AS INTEGER
g AS INTEGER
B AS INTEGER
END TYPE
TYPE cpaltype
r AS INTEGER
g AS INTEGER
B AS INTEGER
END TYPE
DIM SHARED copal(0 TO 255) AS copaltype
DIM SHARED cpal(0 TO 255) AS cpaltype
DIM SHARED pal(0 TO 255) AS LONG
DIM SHARED pal2(0 TO 255) AS LONG
DIM SHARED byte AS STRING * 1
DIM SHARED bbyte AS STRING * 320

''''''''''''''''INPUT THE FILE NAME''''''''''''''''''''''''''''''''''''''

ON ERROR GOTO contin
FILES dir$ + "*.pcx"
contin:
PRINT "What file would you like to view?"

INPUT "", pcxfile$
IF UCASE$(RIGHT$(pcxfile$, 4)) = ".PCX" THEN
pcxfile$ = LEFT$(pcxfile$, LEN(pcxfile$) - 4)
END IF
OPEN dir$ + pcxfile$ + ".pcx" FOR BINARY AS #1
IF LOF(1) = 0 THEN
CLS
PRINT pcxfile$ + ".pcx does NOT exist"
CLOSE #1: KILL dir$ + pcxfile$ + ".pcx"
GOTO contin:
END IF
CLS
PRINT pcxfile$ + ".pcx"
PRINT "legnth of file(compressed) = "; LOF(1)
pointer = LOF(1) - 767
onepercent = INT(LOF(1) / 100)

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

GETPAL
DECODE
pointer2 = 1

SCALEIT
CLOSE #1: CLOSE #2:
KILL "tttt.ttt" 'this is a tempory file buffer
CLS
PRINT "THANK YOU FOR USING PCXMAN!"
END

SUB BRIGHTNESS (preference, palstyle)
brighten = 1: darken = 2: normal = 0: abnormal = 1


FOR index = 0 TO 255
IF preference = brighten THEN
  IF cpal(index).r < 62 THEN cpal(index).r = cpal(index).r + 2
  IF cpal(index).g < 62 THEN cpal(index).g = cpal(index).g + 2
  IF cpal(index).B < 62 THEN cpal(index).B = cpal(index).B + 2
  IF copal(index).r < 62 THEN copal(index).r = copal(index).r + 2
  IF copal(index).g < 62 THEN copal(index).g = copal(index).g + 2
  IF copal(index).B < 62 THEN copal(index).B = copal(index).B + 2
END IF
IF preference = darken THEN
  IF cpal(index).r > 1 THEN cpal(index).r = cpal(index).r - 2
  IF cpal(index).g > 1 THEN cpal(index).g = cpal(index).g - 2
  IF cpal(index).B > 1 THEN cpal(index).B = cpal(index).B - 2
  IF copal(index).r > 1 THEN copal(index).r = copal(index).r - 2
  IF copal(index).g > 1 THEN copal(index).g = copal(index).g - 2
  IF copal(index).B > 1 THEN copal(index).B = copal(index).B - 2
END IF
pal(index) = cpal(index).r + cpal(index).g * 256 + cpal(index).B * 65536
pal2(index) = copal(index).r + copal(index).g * 256 + copal(index).B * 65536
NEXT index

IF palstyle = normal THEN PALETTE USING pal(0)
IF palstyle = abnormal THEN PALETTE USING pal2(0)

END SUB

SUB DECODE
OPEN "tttt.ttt" FOR BINARY AS #2
SEEK #1, 1
GET #1, 1, headerinfo

PRINT "hieght of image = "; headerinfo.theheigth
PRINT "width of image = "; headerinfo.thewidth
PRINT "horizontal pixels = "; headerinfo.horpixels
PRINT "vertical pixels = "; headerinfo.vetpixels



PRINT "decoding image..."
LINE (10 - 1, 75 - 1)-(10 + 100 + 1, 85 + 1), 77, B
''''''''''DECODE IMAGE INTO A TEMPORARY FILE #2'''''''''''''''''''''''''''
numcolorbytes = LOF(1) - palbytes
pointer = 129                                         'SKIP HEADER
pointer2 = 1
DIM colorbyte AS STRING * 200
DIM putstring AS STRING * 200
slot% = 1
putslot% = 1

GET #1, pointer, colorbyte

startcoding:
IF pointer > numcolorbytes THEN GOTO FINISHCODING
IF slot% = 201 THEN
pointer = pointer + 200
counter% = counter% + 200
GET #1, pointer, colorbyte
slot% = 1
END IF
IF putslot% = 201 THEN
PUT #2, , putstring
putslot% = 1
END IF

         
IF counter% >= onepercent THEN
csize = csize + 1
LINE (10, 75)-(10 + csize, 85), 22, BF
LOCATE 8, 17: PRINT csize; "% uncompressed"
counter% = 0
END IF

putbyte$ = MID$(colorbyte, slot%, 1)
IF ASC(putbyte$) < 192 THEN
MID$(putstring, putslot%, 1) = putbyte$ 'PUT #2, , putbyte$                                           'PUT COLOR TO #2
slot% = slot% + 1
putslot% = putslot% + 1
GOTO startcoding
END IF

IF ASC(putbyte$) > 191 THEN
runs% = ASC(putbyte$) - 192
slot% = slot% + 1

IF slot% > 200 THEN
pointer = pointer + 200
counter% = counter% + 200
GET #1, pointer, colorbyte
slot% = 1
END IF

IF putslot% > 200 THEN
PUT #2, , putstring
putslot% = 1
END IF


putbyte$ = MID$(colorbyte, slot%, 1)

IF counter% >= onepercent THEN
csize = csize + 1
LINE (10, 75)-(10 + csize, 85), 22, BF
LOCATE 8, 17: PRINT csize; "% uncompressed"
counter% = 0
END IF




FOR putit% = 1 TO runs%
MID$(putstring, putslot%, 1) = putbyte$
putslot% = putslot% + 1
IF putslot% = 201 THEN
PUT #2, , putstring
putslot% = 1
END IF
NEXT putit%

slot% = slot% + 1


GOTO startcoding
END IF


FINISHCODING:


LINE (10, 75)-(10 + 100, 85), 22, BF
LOCATE 8, 17: PRINT "100% uncompressed!"
LOCATE 13, 1: PRINT "uncompressed image = "; LOF(2)
LINE (0, 0)-(320, 0), 0: LINE (0, 0)-(0, 200), 0

END SUB

SUB FLOODPAL (floodcolor)

FOR index = 0 TO 255
copal(index).r = cpal(index).r
copal(index).g = cpal(index).g
copal(index).B = cpal(index).B
NEXT


red = 1: green = 2: blue = 3: violet = 4: purple = 5: orange = 6: turquoise = 7
blackwhite = 8: yellow = 9: rainbow = 10


FOR index = 0 TO 255
avg% = INT(copal(index).r + copal(index).g + copal(index).B) / 3
copal(index).r = 0: copal(index).g = 0: copal(index).B = 0
IF floodcolor = red THEN copal(index).r = avg%
IF floodcolor = green THEN copal(index).g = avg%
IF floodcolor = blue THEN copal(index).B = avg%
IF floodcolor = violet THEN
copal(index).B = INT(avg% * 1 / 2)
copal(index).r = INT(avg% * 1 / 2)
END IF
IF floodcolor = purple THEN
copal(index).B = INT(avg% * 2 / 3)
copal(index).r = INT(avg% * 1 / 3)
END IF
IF floodcolor = orange THEN
copal(index).r = INT(avg% * 8 / 8)
copal(index).g = INT(avg% * 3 / 8)
END IF
IF floodcolor = turquoise THEN
copal(index).B = INT(avg% * 1 / 2)
copal(index).g = INT(avg% * 1 / 2)
END IF
IF floodcolor = blackwhite THEN
copal(index).r = INT(avg%)
copal(index).g = INT(avg%)
copal(index).B = INT(avg%)
END IF
IF floodcolor = yellow THEN
copal(index).r = INT(avg% * 4 / 4)
copal(index).g = INT(avg% * 4 / 4)
copal(index).B = INT(avg% * 0 / 4)
END IF
IF floodcolor = rainbow THEN
GOTO rainbows
rainbowsdone:
END IF

pal2(index) = copal(index).r + copal(index).g * 256 + copal(index).B * 65536
NEXT

PALETTE USING pal2(0)
EXIT SUB

rainbows:
RANDOMIZE TIMER
pref% = INT(RND * 20) + 1
phase% = INT(RND * 3) + 1
result% = pref%
result% = INT(RND * result%)

IF phase% = 1 THEN
copal(index).r = INT(avg% * result% / pref%)
result% = pref% - result%
result% = INT(RND * result%)
copal(index).g = INT(avg% * result% / pref%)
result% = pref% - result%
copal(index).B = INT(avg% * result% / pref%)
GOTO donemanipulating
END IF

IF phase% = 2 THEN
copal(index).g = INT(avg% * result% / pref%)
result% = pref% - result%
result% = INT(RND * result%)
copal(index).B = INT(avg% * result% / pref%)
result% = pref% - result%
copal(index).r = INT(avg% * result% / pref%)
GOTO donemanipulating
END IF

IF phase% = 3 THEN
copal(index).B = INT(avg% * result% / pref%)
result% = pref% - result%
result% = INT(RND * result%)
copal(index).g = INT(avg% * result% / pref%)
result% = pref% - result%
copal(index).r = INT(avg% * result% / pref%)
GOTO donemanipulating
END IF




donemanipulating:
GOTO rainbowsdone




END SUB

SUB GETPAL
PRINT "loading palette..."
FOR index = 0 TO 255
GET #1, pointer, byte: red = CINT(ASC(byte) / 4) - 1: IF red = -1 THEN red = 0
cpal(index).r = red
GET #1, pointer + 1, byte: green = CINT(ASC(byte) / 4) - 1: IF green = -1 THEN green = 0
cpal(index).g = green
GET #1, pointer + 2, byte: blue = CINT(ASC(byte) / 4) - 1: IF blue = -1 THEN blue = 0
cpal(index).B = blue
pal(index) = red + green * 256 + blue * 65536
pointer = pointer + 3
NEXT index
PALETTE USING pal(0)
LOCATE 3, 19: PRINT "...finished!"

END SUB

SUB SAVESCREEN
DEF SEG = 40960
DIM index AS LONG
DIM makebyte AS STRING * 1
number% = 0
savedecision:
num$ = STR$(number%)
thisfile$ = dir$ + LEFT$(pcxfile$, 6) + num$ + ".pcx"
IF number% < 10 THEN MID$(thisfile$, LEN(thisfile$) - 5, 1) = "0"
CLOSE #4
OPEN thisfile$ FOR BINARY AS #4
IF LOF(4) <> 0 THEN
number% = number% + 1
GOTO savedecision
END IF

IF number% = 99 THEN
PRINT "WARNING!!! YOU HAVE TOO MANY REVISIONS IN THIS DIRECTORY."
PRINT "MOVE SOME OF THE REVESISONS OUT OF THE DIRECTORY TO CONTINUE"
END IF

'If I didn't include this, there would be nothing but chaos!
headerinfo.thewidth = 319
headerinfo.theheigth = 199
headerinfo.horpixels = 320
headerinfo.vetpixels = 200
headerinfo.bpl = 320

PUT #4, , headerinfo


DIM first AS INTEGER
DIM second AS INTEGER
DIM putbyte AS STRING * 1
index = 0
runs = 1
onerun$ = CHR$(193)

nextb:

IF index > 64000 THEN GOTO finished


first = PEEK(index)
second = PEEK(index + 1)
IF runs = 63 THEN GOTO putit

IF first = second THEN
runs = runs + 1
index = index + 1
GOTO nextb
END IF

IF first <> second THEN
putit:
putbyte = CHR$(first)
  IF runs = 1 THEN
    IF first > 191 THEN
      PUT #4, , onerun$
      PUT #4, , putbyte
      index = index + 1
      runs = 1
      GOTO nextb
      END IF
    IF first < 192 THEN
      PUT #4, , putbyte
      index = index + 1
      runs = 1
      GOTO nextb
      END IF
  END IF
  IF runs > 1 THEN
    putruns$ = CHR$(192 + runs)
    PUT #4, , putruns$
    PUT #4, , putbyte
    index = index + 1
    runs = 1
    GOTO nextb

  END IF
END IF

finished:

a$ = CHR$(12)  'For some reason this number has to be 12 for 256 color images
PUT #4, , a$

B$ = SPACE$(1)

IF palstyle = abnormal THEN
FOR index = 0 TO 255
B$ = CHR$(copal(index).r * 4)
PUT #4, , B$
B$ = CHR$(copal(index).g * 4)
PUT #4, , B$
B$ = CHR$(copal(index).B * 4)
PUT #4, , B$
NEXT
END IF

IF palstyle = normal THEN
FOR index = 0 TO 255
B$ = CHR$(cpal(index).r * 4)
PUT #4, , B$
B$ = CHR$(cpal(index).g * 4)
PUT #4, , B$
B$ = CHR$(cpal(index).B * 4)
PUT #4, , B$
NEXT index
END IF

LOCATE 1, 1: PRINT "done"; number%
CLOSE #4
END SUB

SUB SCALEIT
SCREEN 13:
IF scale = 0 THEN scale = 1

x1 = 1
y1 = 1
x2 = 320
y2 = 200

'COOL COLORS
red = 1: green = 2: blue = 3: violet = 4: purple = 5: orange = 6: turquoise = 7
blackwhite = 8: yellow = 9
brighten = 1: darken = 2: normal = 0: abnormal = 1

DETAIL% = 1
horposition% = 0    'this means it has not been scrolled at all
verposition% = 0    'likewise
scale% = 1         'how big is each pixel
shrinkfactor% = 1
shrinkfactory% = 1
evenshrink% = 1
maximumx = x2     'maximum horizontal view capacity x
maximumy = y2   'maximum vertical view capacity y
startx% = x1: finishx% = maximumx: starty% = y1: finishy% = maximumy
normal = 0: reverse = 1

resize:
IF drawx = normal THEN
directionx% = 1: startx% = x1: finishx% = (maximumx) * shrinkfactory% / shrinkfactor%
END IF
IF drawx = reverse THEN
directionx% = -1: startx% = (maximumx) * shrinkfactory% / shrinkfactor%: finishx% = x1
END IF
IF drawy = normal THEN
directiony% = 1: starty% = y1: finishy% = maximumy
END IF
IF drawy = reverse THEN
directiony% = -1: starty% = maximumy: finishy% = y1
END IF



''''''''''''''make a draw capacity variable from this''''''''''''''''''''''

drawoffset = maximumx - headerinfo.thewidth + 1
IF drawoffset < 0 THEN drawoffset = 0
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

maxwidth = (maximumx - x1 + 1) / scale%
maxheigth = maximumy / scale%
maxdisplay = maxwidth * maxheigth
wwidth = headerinfo.bpl
IF headerinfo.bpl = 0 THEN wwidth = headerinfo.thewidth + 1
DIM BY AS STRING * 1
offset = wwidth - maxwidth

'here lies one long if statement
IF scale% = 1 AND psycho = 0 AND horposition% = 0 AND verposition% = 0 AND DETAIL% = 1 AND shrinkfactor% = 1 AND shrinkfactory% = 1 AND evenshrink% = 1 THEN
TINYDRAW
GOTO userinput
END IF

'<<<<<<<<<<<<<<<here is the super slow drawing engine>>>>>>>>>>>>>>>>>>>>
index = 0
FOR y% = starty% TO finishy% STEP (scale% * directiony%)
FOR x% = startx% TO finishx% STEP (scale% * directionx%)
ptr = INT(index / maxwidth) * wwidth + index MOD maxwidth + horposition% + (wwidth * verposition%)
ptr = ptr * evenshrink% * DETAIL%
index = index + shrinkfactor%
GET #2, ptr + 1, BY
IF psycho = 1 THEN LINE (x%, 0)-(x% + scale% - 1, y% + scale% - 1), ASC(BY), BF
IF flash = 1 THEN LINE (x%, 0)-(x% + scale% - 1, y% + scale% - 1), ASC(BY), B
IF scalestyle = normal THEN LINE (x%, y%)-(x% + scale% - 1, y% + scale% - 1), ASC(BY), BF
IF scalestyle = abnormal THEN LINE (x%, y%)-(x% + scale% - 1, y% + scale% - 1), ASC(BY), B
IF INKEY$ <> "" THEN GOTO userinput
NEXT x%
NEXT y%

''''''''''''''''''''''''' USER INPUT ''''''''''''''''''''''''''''''''''''''
userinput:
DO
inp$ = INKEY$
IF twinkle = 1 AND INKEY$ = "" THEN inp$ = "a"
SELECT CASE inp$
CASE "6": horposition% = horposition% + 25
GOTO resize
CASE "4": horposition% = horposition% - 25
IF horposition% < 0 THEN horposition% = 0
GOTO resize
CASE "8": verposition% = verposition% - 25
IF verposition% < 0 THEN verposition% = 0
GOTO resize
CASE "2": verposition% = verposition% + 25: GOTO resize


CASE "5"
scale% = scale% + 1:
horposition% = horposition% + 25
verposition% = verposition% + 25
GOTO resize

CASE "0"
scale% = scale% - 1:
IF horposition% > 24 THEN horposition% = horposition% - 25
IF verposition% > 24 THEN verposition% = verposition% - 25
GOTO resize

CASE ","
scale% = scale% + 1
DETAIL% = DETAIL% + 1
GOTO resize
CASE "."
scale% = scale% - 1
DETAIL% = DETAIL% - 1
IF DETAIL% < 1 THEN DETAIL% = 1
IF scale% < 1 THEN scale% = 1
GOTO resize

CASE CHR$(27): GOTO thatsall
CASE "+": shrinkfactor% = 1: shrinkfactory% = 1: evenshrink% = evenshrink% + 1
GOTO resize
CASE "-": shrinkfactor% = 1: shrinkfactory% = 1: evenshrink% = evenshrink% - 1
IF evenshrink% < 1 THEN evenshrink% = 1
GOTO resize
CASE "7": evenshrink% = 1: shrinkfactor% = shrinkfactor% + 1
GOTO resize
CASE "1": evenshrink% = 1: shrinkfactor% = shrinkfactor% - 1
IF shrinkfactor% < 1 THEN shrinkfactor% = 1
GOTO resize
CASE "9": evenshrink% = 1: shrinkfactory% = shrinkfactory% + 1
GOTO resize
CASE "3": evenshrink% = 1: shrinkfactory% = shrinkfactory% - 1
IF shrinkfactory% < 1 THEN shrinkfactory% = 1
GOTO resize

abnormal = 1
CASE "*"
IF drawy = normal THEN
drawy = reverse
GOTO resize
END IF
drawy = normal
GOTO resize
CASE "/"
IF drawx = normal THEN
drawx = reverse
GOTO resize
END IF
CASE "r", "R": FLOODPAL red: palstyle = abnormal
CASE "g", "G": FLOODPAL green: palstyle = abnormal
CASE "b", "B": FLOODPAL blue: palstyle = abnormal
CASE "n", "N": PALETTE USING pal(0): palstyle = normal
CASE "v", "V": FLOODPAL violet: palstyle = abnormal
CASE "p", "P": FLOODPAL purple: palstyle = abnormal
CASE "o", "O": FLOODPAL orange: palstyle = abnormal
CASE "t", "T": FLOODPAL turquoise: palstyle = abnormal
CASE "w", "W": FLOODPAL blackwhite: palstyle = abnormal
CASE "y", "Y": FLOODPAL yellow: palstyle = abnormal
CASE "a", "A": FLOODPAL 10: palstyle = abnormal

CASE "]": BRIGHTNESS brighten, palstyle
CASE "[": BRIGHTNESS darken, palstyle
CASE "z"
IF scalestyle = normal THEN
scalestyle = abnormal
GOTO resize
END IF
scalestyle = normal
GOTO resize
CASE "i"
PRINT "i"
CASE "x", "X"
IF psycho = 0 THEN
psycho = 1
flash = 0
ELSE
psycho = 0
END IF
GOTO resize
CASE "f", "F"
IF flash = 0 THEN
flash = 1
psycho = 0
ELSE
flash = 0
END IF
GOTO resize
CASE "s", "S"
SAVESCREEN
CASE CHR$(8)
scale% = 1: psycho = 0: horposition% = 0: verposition% = 0: DETAIL% = 1: shrinkfactor% = 1: shrinkfactory% = 1: evenshrink% = 1
GOTO resize
CASE "c", "C"
IF twinkle = 0 THEN
twinkle = 1
ELSE
twinkle = 0
END IF
GOTO resize

END SELECT

LOOP

thatsall:


END SUB

SUB TINYDRAW
bigoffsetx = 0
bigoffsety = 0
tinyoffx = 0
tinyoffy = 0
IF headerinfo.thewidth > 319 THEN bigoffsetx = headerinfo.thewidth - 319
IF headerinfo.theheigth > 199 THEN bigoffsety = headerinfo.theheigth - 199
IF headerinfo.thewidth < 319 THEN tinyoffx = 319 - headerinfo.thewidth
IF headerinfo.theheigth < 199 THEN tinyoffy = 199 - headerinfo.theheigth

pointer2 = 1
add = 0
w = headerinfo.thewidth


TINYDRAW:
pointer2 = 1
FOR y% = 1 TO 200 - tinyoffy
GET #2, pointer2, bbyte$
FOR x% = 1 TO 320 - tinyoffx
PSET (x%, y%), ASC(MID$(bbyte$, x%, 1))
NEXT x%
pointer2 = pointer2 + 320 + bigoffsetx - tinyoffx
NEXT y%


END SUB

